Imports Microsoft.VisualBasic
Imports System.Runtime.InteropServices

Namespace Win32API

Public Class Win32

Private Declare Function xBeep Lib "Kernel32.DLL" Alias "Beep" (ByVal dwFreq As Integer, ByVal dwDuration As Integer) As Integer

Public Function Beep(ByVal dwFreq As Integer, ByVal dwDuration As Integer) As Integer
Beep=xBeep(dwFreq, dwDuration)
End Function

Private Declare Function xFindWindow Lib "User32.DLL" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Integer

Public Function FindWindow(ByVal lpClassName As String, ByVal lpWindowName As String) As Integer
If lpClassName = "" Then lpClassName = vbNullString
If lpWindowName = "" Then lpWindowName = vbNullString
FindWindow = xFindWindow(lpClassName, lpWindowName)
End Function

Private Declare Function xSetForegroundWindow Lib "User32.DLL" Alias "SetForegroundWindow" (ByVal hwnd As Integer) As Integer

Public Function SetForegroundWindow(ByVal hwnd As Integer) As Integer
SetForegroundWindow = xSetForegroundWindow(hwnd)
End Function

Private Declare Sub xSleep Lib "Kernel32.DLL" Alias "Sleep" (ByVal dwMilliseconds As Integer)

Public Sub Sleep(ByVal dwMilliseconds As Integer)
Call xSleep(dwMilliseconds)
End Sub

Private Declare Sub xkeybd_event Lib "User32.DLL" Alias "keybd_event" (ByVal bVk As Byte, ByVal bScan As Byte, ByVal dwFlags As Integer, ByVal dwExtraInfo As Integer)

Public Sub keybd_event(ByVal bVk As Byte, ByVal bScan As Byte, ByVal dwFlags As Integer, ByVal dwExtraInfo As Integer)
Call xkeybd_event(bVk, bScan, dwFlags, dwExtraInfo)
End Sub

Private Declare Function xGetWindow Lib "User32.DLL" Alias "GetWindow" (ByVal hwnd As Integer, ByVal wCmd As Integer) As Integer

Public Function GetWindow(ByVal hwnd As Integer, ByVal wCmd As Integer) As Integer
GetWindow = xGetWindow(hwnd, wCmd)
End Function

Private Declare Function xGetWindowText Lib "User32.DLL" Alias "GetWindowTextA" (ByVal hwnd As Integer, ByVal lpString As   System.Text.StringBuilder, ByVal cch As Integer) As Integer

Public Function GetWindowText(ByVal hwnd As Integer) As String
Dim lngBytes As Integer
Dim sb As New System.Text.StringBuilder(256)
lngBytes = xGetWindowText(hwnd, sb, sb.Capacity + 1)
Return sb.ToString()
End Function

Private Declare Function xIsWindowVisible Lib "User32.DLL" Alias "IsWindowVisible" (ByVal hwnd As Integer) As Integer

Public Function IsWindowVisible(ByVal hwnd As Integer) As Integer
IsWindowVisible = xIsWindowVisible(hwnd)
End Function

Private Declare Function xGetClassName Lib "User32.DLL" Alias "GetClassNameA" (ByVal hwnd As Integer, ByVal lpClassName As System.Text.StringBuilder, ByVal nMaxCount As Integer) As Integer

Public Function GetClassName(ByVal hwnd As Integer) As String
Dim lngBytes As Integer
Dim sb As New System.Text.StringBuilder(256)
lngBytes = xGetClassName(hwnd, sb, sb.Capacity + 1)
Return sb.ToString()
End Function

Private Declare Function xGetTopWindow Lib "User32.DLL" Alias "GetTopWindow" (ByVal hwnd As Integer) As Integer

Public Function GetTopWindow(ByVal hwnd As Integer) As Integer
GetTopWindow = xGetTopWindow(hwnd)
End Function

Private Declare Function xGetDesktopWindow Lib "User32.DLL" Alias "GetDesktopWindow" () As Integer

Public Function GetDesktopWindow() As Integer
GetDesktopWindow = xGetDesktopWindow()
End Function

Private Declare Function xGetWindowThreadProcessId Lib "User32.DLL" Alias "GetWindowThreadProcessId" (ByVal hwnd As Integer, lpdwProcessId As Integer) As Integer

Public Function GetWindowThreadProcessId(ByVal hwnd As Integer, lpdwProcessId As Integer) As Integer
GetWindowThreadProcessId = xGetWindowThreadProcessId(hwnd, lpdwProcessId)
End Function

Private Declare Function xShowWindow Lib "User32.DLL" Alias "ShowWindow" (ByVal hwnd As Integer, ByVal nCmdShow As Integer) As Integer

Public Function ShowWindow(ByVal hwnd As Integer, ByVal nCmdShow As Integer) As Integer
ShowWindow = xShowWindow(hwnd, nCmdShow)
End Function

Private Declare Function xSetWindowPos Lib "User32.DLL" Alias "SetWindowPos" (ByVal hwnd As Integer, ByVal hWndInsertAfter As Integer, ByVal x As Integer, ByVal y As Integer, ByVal cx As Integer, ByVal cy As Integer, ByVal wFlags As Integer) As Integer

Public Function SetWindowPos(ByVal hwnd As Integer, ByVal hWndInsertAfter As Integer, ByVal x As Integer, ByVal y As Integer, ByVal cx As Integer, ByVal cy As Integer, ByVal wFlags As Integer) As Integer
SetWindowPos = xSetWindowPos(hwnd, hWndInsertAfter, x,  y, cx, cy, wFlags)
End Function

Private Declare Function xGetWindowLong Lib "User32.DLL" Alias "GetWindowLongA" (ByVal hwnd As Integer, ByVal nIndex As Integer) As Integer

Public Function GetWindowLong(ByVal hwnd As Integer, ByVal nIndex As Integer) As Integer
GetWindowLong = xGetWindowLong(hwnd, nIndex)
End Function

Public Function GetError() As Object
GetError = Err
End Function

End Class 'Win32

End NameSpace 'Win32API